Points in Segments(区间中的点)

2024-01-10 17:38
文章标签 区间 points segments

本文主要是介绍Points in Segments(区间中的点),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题链接

Given n points (1 dimensional) and q segments, you have to find the number of points that lie in each of the segments. A point pi will lie in a segment A B if A ≤ pi ≤ B.For example if the points are 1, 4, 6, 8, 10. And the segment is 0 to 5. Then there are 2 points that lie in the segment.

Input

Input starts with an integer T (≤ 5), denoting the number of test cases.Each case starts with a line containing two integers n (1 ≤ n ≤ 10 ^ 5) and q (1 ≤ q ≤ 50000). The next line contains n space separated integers denoting the points in ascending order. All the integers are distinct and each of them range in [0, 10 ^ 8].Each of the next q lines contains two integers Ak Bk (0 ≤ Ak ≤ Bk ≤ 108) denoting a segment.

Output

For each case, print the case number in a single line. Then for each segment, print the number of points that lie in that segment.

Sample Input

1
5 3
1 4 6 8 10
0 5
6 10
7 100000

Sample Output

Case 1:
2
3
2

Note

Dataset is huge, use faster I/O methods.

单词

  • Segment 部份,区间
  • dimensional 尺寸
  • ascending order 升序
  • space separated 空格分隔的

原文翻译

给定n个点(一维)和q个区间,您必须找到每个区间中的点数。 如果A ≤ pi ≤ B,则点pi将位于区间A B中。例如,如果点是1、4、6、8、10,并且区间是0到5。则区间中有2个点。
输入以整数T(≤5)开头,表示测试用例的数量。
每种测试用例的第一行包含两个整数n(1 ≤ n ≤ 10 ^ 5)和q(1 ≤ q ≤ 50000)。下一行包含n个以空格分隔的整数,这些整数按升序表示点。 所有整数都是不同的,并且每个整数的范围都在[0,10 ^ 8]。
接下来的q行,每行包含两个整数Ak Bk(0 ≤ Ak ≤ Bk ≤ 10 ^ 8)表示区间。
对于每种情况,请在一行中打印样例编号。 然后,对于每个区间,打印该区间中的点数。

知识点

  • lower_bound: 返回数列中第一个大于或者等于所查询数的位置,没有大于等于所查询数返回数列长度
  • upper_bound: 返回数列中第一个大于所查询数的位置,没有大于所查询的数返回数列长度

样例分析

1
5 3
1 4 6 8 10
0 5
6 10
7 100000

  • 对于第一组区间0 5

    upper_bound(a,a + n,5)会返回第一个大于5的位置 — 2
    lower_bound(a,a + n,0)会返回第一个大于等于0的位置—0
    upper_bound(a,a + n,5) - lower_bound(a,a + n,0) = 2;

  • 对于第二组区间6 10
    upper_bound(a,a + n,10)会返回第一个大于10的位置 — 5(数列长度)
    lower_bound(a,a + n,6)会返回第一个大于等于6的位置—2
    upper_bound(a,a + n,10) - lower_bound(a,a + n,6) = 3;

  • 对于第三组区间7 100000
    upper_bound(a,a + n,100000)会返回第一个大于100000的位置 — 5(数列长度)
    lower_bound(a,a + n,7)会返回第一个大于等于7的位置—3
    upper_bound(a,a + n,100000) - lower_bound(a,a + n,7) = 2;

故若区间为[x,y],输出的答案为upper_bound(a,a + n,y) - lower_bound(a,a + n,x);

AC代码:

#include <cstdio>
#include <iostream>
#include <algorithm>using namespace std;const int N = 1e5 + 10;
int a[N];
int n,q;//n、q分别表示数组中的元素个数和区间个数
int x,y;//表示区间int main()
{int t;scanf("%d",&t);//多组测试数据for (int k = 1;k <= t;k++){printf("Case %d:\n",k);scanf("%d%d",&n,&q);for (int i = 0;i < n;i++) scanf("%d",&a[i]);//读入n个数while (q--)//q组区间{scanf("%d%d",&x,&y);int ans1 = int(upper_bound(a,a + n,y) - a);int ans2 = int(lower_bound(a,a + n,x) - a);printf("%d\n",ans1 - ans2);}}return 0;
}

这篇关于Points in Segments(区间中的点)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/591567

相关文章

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu4267区间统计

题意:给一些数,有两种操作,一种是在[a,b] 区间内,对(i - a)% k == 0 的加value,另一种操作是询问某个位置的值。 import java.io.BufferedInputStream;import java.io.BufferedReader;import java.io.IOException;import java.io.InputStream;import

hdu4417区间统计

给你一个数列{An},然后有m次查询,每次查询一段区间 [l,r] <= h 的值的个数。 import java.io.BufferedInputStream;import java.io.BufferedReader;import java.io.IOException;import java.io.InputStream;import java.io.InputStreamRead

hdu3333区间统计

题目大意:求一个区间内不重复数字的和,例如1 1 1 3,区间[1,4]的和为4。 import java.io.BufferedInputStream;import java.io.BufferedReader;import java.io.IOException;import java.io.InputStream;import java.io.InputStreamReader;

【uva】11536-Smallest Sub-Array(区间移动问题)

一个区间移动的问题,1A了,感觉没什么好说的。。 13975926 11536 Smallest Sub-Array Accepted C++ 0.809 2014-08-01 11:00:20 #include<cstdio>#include<cstring>#include<iostream>using namespace std;#define INF 1 << 30

【hdu】Just a Hook(线段树区间修改)

线段树模板题,练的是懒惰标记。 懒惰标记,就是更新一段区间的时候,如果小区间被包含在了所需要更新的区间里面,那么直接对代表这个区间的数组元素赋值,之后做一个标记(表示这个区间的子区间都需要更新)但是不继续递归(这样可以节省很多的时候)。 116571152014-09-15 14:17:26Accepted1698796MS2380K1750 BG++KinderRiven #

【hdu】I Hate It(线段树,结点修改求区间最大值)

线段树的模板题,还是二分递归。 #include <iostream>#include <cstdlib>#include <cstdio>#include <string>#include <cstring>#include <cmath>#include <vector>#include <queue>#include <set>#include <map>#incl

【hdu】敌兵布阵(线段树,更加结点,区间求和)

最近开始刷线段树,主要围绕notonlysuccess的线段树总结刷。 结点修改还是比较简单的,不需要什么懒惰标记,直接二分递归就可以了。 #include <iostream>#include <cstdlib>#include <cstdio>#include <string>#include <cstring>#include <cmath>#include <vecto

ZOJ 3324 Machine(线段树区间合并)

这道题网上很多代码是错误的,由于后台数据水,他们可以AC。 比如这组数据 10 3 p 0 9 r 0 5 r 6 9 输出应该是 0 1 1 所以有的人直接记录该区间是否被覆盖过的方法是错误的 正确方法应该是记录这段区间的最小高度(就是最接近初始位置的高度),和最小高度对应的最长左区间和右区间 开一个sum记录这段区间最小高度的块数,min_v 记录该区间最小高度 cover

【Leetcode56】合并区间(数组 | 排序)

文章目录 一、题目二、思路三、代码 一、题目 二、思路 先将所有子列表按照start_pos进行排序,有利于保持顺序性,每次处理新子列表时,只用和结果列表ans_lst的最后一个子列表对比,如果有重合则合并,然后将合并的新子列表插入结果列表排序可以使用lambda函数,intervals.sort(key=lambda x: x[0])因为使用了sort,所以时间复杂度O(